#
# spec file for package openstack-nova-virt-zvm
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define component nova-zvm-virt-driver

%define version_unconverted 10.0.1.dev6

Name:           openstack-nova-virt-zvm
Version:        10.0.1~dev6
Release:        3.2
Summary:        Z/VM Driver for OpenStack Compute (Nova)
License:        EPL-1.0
Group:          System/Management
Url:            https://wiki.openstack.org/wiki/ZVMDriver
Source:         http://tarballs.openstack.org/nova-zvm-virt-driver/nova-zvm-virt-driver-master.tar.gz
BuildRequires:  fdupes
BuildRequires:  openstack-nova
BuildRequires:  openstack-suse-macros
BuildRequires:  python-base
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
Requires:       openstack-nova
Requires:       python >= 2.7
Requires:       python-oslo.concurrency >= 3.8.0
Requires:       python-oslo.config >= 3.22.0
Requires:       python-oslo.log >= 3.11.0
Requires:       python-oslo.serialization >= 1.10.0
Requires:       python2-oslo.service
Requires:       python-oslo.utils >= 3.20.0
Requires:       python-six >= 1.9.0
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?suse_version} && 0%{?suse_version} <= 1110
%{!?python_sitelib: %global python_sitelib %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%else
BuildArch:      noarch
%endif

%description
The z/VM driver is a hypervisor driver for Openstack Nova Compute.

%package test
Summary:        Z/VM Driver for OpenStack Compute (Nova) - Testsuite
Group:          System/Management
Requires:       %{name} = %{version}
Requires:       python-fixtures >= 3.0.0
Requires:       python-mock >= 1.2
Requires:       python-nova
Requires:       python-oslotest >= 1.10.0
Requires:       python-python-subunit >= 0.0.18
Requires:       python-testrepository >= 0.0.18
Requires:       python-testscenarios >= 0.4
Requires:       python-testtools >= 1.4.0

%prep
%setup -q -n %{component}-%{version_unconverted}
%openstack_cleanup_prep

%description test
The testsuite for the z/VM driver for OpenStack Nova Compute.

%build
python setup.py build

%install
python setup.py install --root %{buildroot} --prefix %{_prefix}

mkdir -p  %{buildroot}%{python_sitelib}/nova_zvm/tests/unit/virt/zvm
cp -a nova_zvm/tests/unit/virt/zvm %{buildroot}%{python_sitelib}/nova_zvm/tests/unit/virt/

install -m 750 -d %{buildroot}%{_localstatedir}/lib/nova/images/spawn_tmp

%fdupes %{buildroot}%{python_sitelib}/nova_zvm*.egg-info

%files
%defattr(-,root,root,-)
%dir %attr(0750, nova, nova) %{_localstatedir}/lib/nova/images/spawn_tmp
%dir %{python_sitelib}/nova
%dir %{python_sitelib}/nova/virt
%dir %{python_sitelib}/nova/virt/zvm
%{python_sitelib}/nova/virt/zvm/
%{python_sitelib}/nova_zvm*.egg-info
%{python_sitelib}/nova_zvm
# Part of test subpackage
%exclude %{python_sitelib}/nova_zvm/tests/unit/virt/zvm/

%files test
%defattr(-,root,root)
%dir %{python_sitelib}/nova_zvm/tests
%dir %{python_sitelib}/nova_zvm/tests/unit
%dir %{python_sitelib}/nova_zvm/tests/unit/virt
%dir %{python_sitelib}/nova_zvm/tests/unit/virt/zvm

%changelog
* Sun Sep 30 2018 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-10.0.1.dev6:
  * Add a Apache-2.0 License to the base dir
  * fix tox python3 overrides
* Sat Sep 29 2018 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-10.0.1.dev3:
  * Fix uuidsentinel
* Tue Sep  4 2018 dmueller@suse.com
- remove mox dependency
* Tue Apr 17 2018 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-10.0.1.dev2:
  * uncap eventlet
* Tue Mar 13 2018 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-10.0.1.dev1:
  * Enhance doc
  10.0.0
* Mon Feb 12 2018 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev75:
  * Fix instance delete bug
  * Add token configuration item
  * Remove mox from requirements
* Wed Jan 10 2018 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev72:
  * set up ca file configuration in drver
* Mon Jan  8 2018 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev71:
  * Add reboot instance driver method
* Fri Jan  5 2018 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev70:
  * Snapshot support
* Tue Jan  2 2018 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev69:
  * fix typos when call guest soft stop
  * update zvm\_connector\_url to URIopt
* Thu Dec 21 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev67:
  * Add vm power action driver methods and get console output
* Wed Dec 20 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev66:
  * switch from xcat backend to smut backend
* Thu Dec 14 2017 Gayane.Osipyan@suse.com
- Update path for test subpackge
* Thu Dec 14 2017 gosipyan@suse.com
- Update to version nova-zvm-virt-driver-8.0.1.dev65:
  * Adopt changes for upstream 511879
  * fix zvm driver.get\_info
  * Modify some wording about introduction
  * Add zuul status and flow
  * Adjust topo information and CI doc
  * Adjust document to reflect latest update
  * Add doc for additional CI information
  * Remove generate conf file temply
  * eventlet support
  * switch to sdk
  * Remove log translations
  * pin sphinx = 1.5.6
  * avoid raise error log when update image failed
  * Add z/VM requirements for doc
  * Add active engine guide
  * Add image guide for image requirements
  * Add additional doc for topo
  * Add doc enhancement for arch picture as topo
  * Fix log debug error
  * Add doc for contributing
  * Add more info into README
  * Will not reraise error out when destroying a failed instance
  * honor zvm\_default\_admin\_userid
  * deprecate zvm\_user\_default\_password
  * Move nova zvm virt driver to separate namespace
  * Updating instance\_fcp\_map correctly when boot-from-volume fails
  * Update root\_disk\_units with CYL or BLK units
  * update doc to add 'images'
  * Add introduction info of zvm driver
  * Add zvm\_default\_admin\_userid conf option
  * Insert os\_version into instance obj when boot-from-volume
  * a following path for fix\_failure\_of\_deploy\_multi\_instances patch
  * avoid import\_image\_to\_nova called by multi threads at a time
  * Fix the image\_meta problem for boot from volume
  * change default value for zvm\_vmrelocate\_immediate
  * Fix issue in resize function that iucv\_authrized\_userid is not changed
  * Fix vm\_mode exception
  * Print exception in driver.\_detach\_volume\_from\_instance
  * add context param to confirm\_migration
  * Make image\_meta a dict instead of object
  * fix wrong comments in power\_on function
  * add instance\_exists function
  * Correct root\_device of instances to be the real one
  * Fix network\_api\_class issue
  * Add debug log for delete\_userid
  * Use get\_xcat\_url to replace XCATUrl()
  * Fix the image\_meta problem when create\_userid
  * WIP: support get\_console\_output
  * Add description for zvm\_host
  * Add conf for zvm\_xcat\_group
  * Update conf for zvm\_image\_compression\_level
  * Add conf for zvm\_xcat\_master
  * Replace assert\_called with called variable
  * Ensure power state is shutdown in power\_off
  * Add info about zvm\_diskpool and zvm\_diskpool\_type
  * adjust usage of default\_ephemeral\_format
  * Update restrictions of vm\_state when attaching/detaching volumes
  * Update restrictions of vm\_state when attach/detach\_volumes
  * Remove ifroute-eth\*
  * using fake\_instance\_obj instead of db.instance
  * Change the way to access block\_device\_mapping properties
  * Get image\_metadata through glance service
  * not use json dump for supported\_instances
  * fix a defect in check\_can\_live\_migrate\_source
  * Use os\_version instead of os\_type in volume metadata
  * [py3] remove \_\_builtin\_\_ function
  * Remove host\_name parameter
  * Replace \_\_builtin\_\_ with six.moves.builtins
  * use six.moves http\_client instead of httpclient
  * Remove \_\_builtin\_\_ usage
  * Return dummy numa\_topology
  * refine finish\_migration unit test cases
  * let get\_info() return an object instead of a dict
* Wed Mar 22 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev27:
  * add support matrix of zvm driver
  * Updating instance_fcp_map correctly when boot-from-volume fails
  * Add configuration file
  * Add oslo.config>=3.22.0 into test requirements
* Tue Mar 21 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev20:
  * Try to do unlock when delete userid failed
  * Update root_disk_units with CYL or BLK units
  * Add zvm_default_admin_userid conf option
  * Do not punch xcat key file to instance
* Sat Mar 18 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev12:
  * Add init document for zvm driver
* Fri Mar 17 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev11:
  * Add handle 503 error from REST layer
* Fri Mar  3 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev10:
  * update requirements.txt
* Tue Feb 28 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-8.0.1.dev9:
  * For SLES system, to keep the NIC setting persistent When boot a system with a NIC which is different from the master system, NIC qeth device will not be initialized when system re-ipl
  8.0.0
* Thu Feb 23 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-0.0.1.dev299:
  * Insert os_version into instance obj when boot-from-volume
* Thu Feb 23 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-0.0.1.dev297:
  * Remove unused logging import
* Tue Feb 21 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-0.0.1.dev295:
  * Revert "Remove the restriction to disable selinux for rhel7.x"
* Sat Feb 18 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-0.0.1.dev293:
  * Remove the restriction to disable selinux for rhel7.x
* Tue Feb 14 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-0.0.1.dev291:
  * now can capture instances with chinese characters
* Thu Feb  9 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-0.0.1.dev290:
  * Enable boot from volume for Ubuntu 16
* Wed Jan 25 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-0.0.1.dev289:
  * Remove version from setup.cfg
  * Correct the hostname when booting from volume
* Fri Jan 20 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev287:
  * Remove redundant WWPN when preparing boot-from-volume
* Thu Jan 19 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev286:
  * Modify to set root device earlier in spawn
  * Modify to use one same command to change password
* Tue Jan 17 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev283:
  * a following path for fix_failure_of_deploy_multi_instances patch
  * Fix the image_meta problem for boot from volume
* Fri Jan 13 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev280:
  * avoid import_image_to_nova called by multi threads at a time
  * Add conf description for live migration
* Thu Jan 12 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev276:
  * follow up of configuration changes
* Wed Jan 11 2017 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev274:
  * change default value for zvm_vmrelocate_immediate
* Thu Dec 22 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev273:
  * ignore error 6312
  * For resize, we should copy and use orignal image's status
* Tue Dec 20 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev270:
  * use uuidutils to generate UUID instead of uuid4
* Wed Dec  7 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev269:
  * Fix issue in resize function that iucv_authrized_userid is not changed
* Tue Dec  6 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev268:
  * Fix vm_mode exception
* Sat Dec  3 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev267:
  * riase correct exception if image prop not valid
  * Bump xcat requirement version
* Thu Dec  1 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev265:
  * Print exception in driver._detach_volume_from_instance
* Tue Nov 29 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev264:
  * I fixed two bugs in this patch. 1) the code in the dist.py correct a display format of content in ifcfg-xxx file to let user easy to grep and show the file content in one line
* Sat Nov 26 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev262:
  * add context param to confirm_migration
  * Modify command to set admin password
* Fri Nov 25 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev259:
  * Fix the issue to change origin VM's status
* Thu Nov 24 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev258:
  * add debug info when bad response returned
  * Add ignore warning message routine
* Wed Nov 23 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev255:
  * ignore bandit issue
* Tue Nov 22 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev253:
  * Remove "management IP" concept from our code
  * Wrong usage of param
* Sat Nov 19 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev250:
  * Replace xdsh restapi to new execcmdonvm
  * Ubuntu volume support - inactive attach/detach
* Fri Nov 18 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev247:
  * Make image_meta a dict instead of object
* Wed Nov 16 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev246:
  * Fix option description
  * IUCV enablement
* Tue Nov 15 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev243:
  * fix wrong comments in power_on function
* Fri Nov 11 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev242:
  * Ubuntu volume support - active attach/detach
  * need raise exception when power on command fail
* Wed Nov  9 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev239:
  * add instance_exists function
* Wed Oct 19 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev238:
  * check power status use wrong function
  * Raise exception when loop check failed
* Tue Oct 18 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev235:
  * Collect xCAT diagnostics if a deployment times out
* Sat Oct 15 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev234:
  * fix pep8 failure of N354 and N342
* Tue Oct 11 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev233:
  * Add support of cpumempowrestat
* Sat Oct  8 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev231:
  * Need another loop check if nic info not ready
* Fri Sep 23 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev230:
  * Ensure OpenStack request ID is added to request, when present
* Wed Sep 21 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev229:
  * Fix vif.id usage
  * Performance enhance to remove couple operation
* Thu Sep 15 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev226:
  * Downgrade log message from error to warning
* Tue Sep 13 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev224:
  * Return default device name for volume attaching in IBM zvm env
* Fri Sep  9 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev223:
  * Prompt error if instance name is longer than 8 charactors
* Tue Sep  6 2016 tbechtold@suse.com
- Update to version nova-zvm-virt-driver-5.0.0.dev222:
  * Modify the default shell used in punched files
  * Fix ubuntu network restart fail problem
  * Fix the network problem and process of non xcatconf4z image
  * Correct root_device of instances to be the real one
  * support instance attributes in copied instance objects
  * Add follow on of conf update
  * Change from --console to --console-output
  * make IPL param only send when mkvm
  * Fix dummy is not valid cfg drive format
  * Rename volume.API to cinder.API
  * add context param to InstanceMetadata
  * Add support for 'T'
  * Add xcat version check when init
  * use warning instead of warn
  * Add description for user direct related conf
  * ignore 400/4 when delete unlocked instance
  * Pass request ID and VM UUID
  * Fix network_api_class issue
  * use full path smcli
  * url > URL in 2 places + xcat > xCAT 1x in utils.py Change-Id: Ib8b636595286d3fa25e1f55a8d66c0b530546949
  * Add debug log for delete_userid
  * Set the default value for zvm user profile
  * Pass osimage when creating userid
  * Modify image import to handle old/new style image
  * Use get_xcat_url to replace XCATUrl()
  * Modify driver to configure ubuntu network
  * Add SLES12 boot-from-volume support
  * Fix the image_meta problem when create_userid
  * Remove a unused param
  * WIP: support get_console_output
  * Make image update not purge property
  * Remove user and project id becuase nova remove it
  * Add exception info into log
  * Use https with CA conf
  * Add description for zvm_host
  * Add conf for zvm_xcat_group
  * Add Hex description
  * Update conf for zvm_image_compression_level
  * Add conf for zvm_xcat_master
  * Replace assert_called with called variable
  * Add conf for 2 image configurations
  * Add conf for xcat related conf
  * Add capability for zvm driver
  * Ensure power state is shutdown in power_off
  * Add more info into configuration doc
  * Add info about zvm_diskpool and zvm_diskpool_type
  * Add conf for timeout value
  * Fix from driver to conf
  * ignore bandit report for tmp dir
  * remove bandit.yaml
  * adjust usage of default_ephemeral_format
* Thu May 12 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev133:
  * Move configuration to a conf file
* Wed May 11 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev132:
  * Support genconfig file
* Tue May 10 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev131:
  * adopt changes of netconf
* Mon May  9 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev130:
  * Add quiet option in xdsh call
* Sat Apr 16 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev129:
  * Remove hard coding NIC vdev
  * Fast deployment support zvm driver
* Wed Mar 16 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev126:
  * Update restrictions of vm_state when attaching/detaching volumes
* Mon Mar 14 2016 tbechtold@suse.com
- Adjust Requires
* Thu Mar 10 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev125:
  * Sles11 image deploy failed with network interface initlize failed
  * Update restrictions of vm_state when attach/detach_volumes
* Thu Mar  3 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev123:
  * change from rm -fr to rm -f
  * Remove ifroute-eth*
* Fri Feb 26 2016 cloud-devel@suse.de
- Update to version nova-zvm-virt-driver-5.0.0.dev121:
  * Adjust interval in wait unlock looping call
  * resize ephemeral disk
  * More robust determination of running user name for xcat access
* Sat Feb 20 2016 dmueller@suse.com
- Update to version nova-zvm-virt-driver-5.0.0.dev117:
  * Change imagemeta from dict to obj in test
  * using fake_instance_obj instead of db.instance
  * Restrict acceptable states of the instance when attaching volumes
  * Change the way to access block_device_mapping properties
  * Get image_metadata through glance service
  * not use json dump for supported_instances
  * fix a defect in check_can_live_migrate_source
  * Use os_version instead of os_type in volume metadata
  * fix unittest failure
  * Fix two defects
  * Update from global requirements
  * re-try if init zvm driver failed
  * Add bandit test to tox
  * [Py3] Fixes dict keys and items references
  * [py3] values should be list in py3
  * [py3] remove __builtin__ function
  * Add license and description statment into setup.cfg
  * A new way to decide if the type is string instead of by isinstance
  * [py34] Remove basestring usage
  * Remove host_name parameter
  * split command of hexdump
  * print error when parse data error
  * Add nozip version and move version to const
  * Add version compare function
  * change according to 26635e7c4
  * Fix bandit 2
  * Detail the log when error occurs
  * Add more info to the log
  * Support host side multipath persistent disks
  * Add missing option into log if option not correct
  drop non-upstreamable patch 01-move-config-options-to-zvm-section.patch
* Thu Dec 10 2015 dmueller@suse.com
- create /var/lib/nova/images/spawn_tmp
* Wed Jul  8 2015 dmueller@suse.com
- fix requires
* Wed Jun 10 2015 mmeister@suse.com
- Initial Version
